import Blender
import nmeshx
import math3d
import sys

def Flatter( mesh, factor ):
	sf = mesh.getSelectedFaces()
	af = mesh.nmesh.getActiveFace()
	if not sf and not af:
		print "Error"
		return None
	af = mesh.getFaceFromNMFace( mesh.nmesh.faces[af] )
	nor = af.getNormal()
	mid = af.getMedianPoint()
	ended = []
	
	for face in sf:
		if face.id == af.id:continue
		for vert in face.bface.v:
			if ended.count( vert.index ):continue
			vc = math3d.Vector( vert.co )
			co = vc- mid
			nco = nor.Cross( co )
			nco = nco.Cross( nor )
			tm = nco.Dot( co ) / nco.Dot( nco )
			hco = (nco * tm) + mid
			lsv = vc.Lerp( hco, factor )
			lsv.ToBlender( vert.co )
			ended.append( vert.index )
	mesh.toBlender()