import math
import math3d
import nmeshx
import subdivider
import selecter
import flatter
import Blender

import Blender.BGL
import Blender.Draw

version = Blender.Get("version")
# debut ---/ correction du 12/08/2003
if version <= 223 or version>=228:
	getSelectedObjects = Blender.Object.GetSelected
else:
	getSelectedObjects = Blender.Object.getSelected
# fin t---/ correction du 12/08/2003

_GL = Blender.BGL
_DR = Blender.Draw

current_mesh = None
winsize = None

def p2rH( v ):
	global winsize
	return winsize[0] * v * 0.01

def p2rV( v ):
	global winsize
	return winsize[1] - ( v * winsize[1] * 0.01 )

# percentage x,y,w,h..
def drawText( t, x, y, col ):
	_GL.glColor3f( *col )
	_GL.glRasterPos2f( *( p2rH(x) , p2rV(y) -15 ) )
	_DR.Text( t )

def drawRect( x, y, w, h , col ):
	_GL.glColor3f( *col )
	x=p2rH(x)
	y=p2rV(y)
	_GL.glRectf( *(x , y, x+p2rH(w), y-p2rV(h) ) )

def drawGUI( fn, args, ofs = 2 ):
	global winsize
	x = p2rH( args[ofs] )
	w = p2rH( args[ofs+2] )
	h = args[ofs+3] * winsize[1] * 0.01
	y = p2rV( args[ofs+1] ) - h
	return fn( *args[0:ofs] + (x,y,w,h) + args[ofs+4:] )

gui_items = [ _DR.Create(1000), _DR.Create(0), _DR.Create(1.0), _DR.Create(1), _DR.Create(0.5) ]
target_state = 0

def getTarget():
	global getSelectedObjects,version
	objs = getSelectedObjects()
    # debut---/ correction du 12/08/2003
	if version < 228:
		if objs and objs[0].data and objs[0].getType() == "Mesh":
			return objs[0].data
	else:
		if objs and objs[0].getData() and objs[0].getType() == "Mesh":
 			return objs[0].getData()
    # fin---/ correction du 12/08/2003
	return None

def draw():
	global winsize, current_mesh, gui_items, getSelectedObjects,target_state
	sz = _GL.Buffer( _GL.GL_FLOAT, 4 )
	_GL.glGetFloatv( _GL.GL_SCISSOR_BOX, sz )
	winsize = [ sz.list[2], sz.list[3] ]
	
	_GL.glClearColor( 0, 0, 0.5 , 0. )
	_GL.glClear( _GL.GL_COLOR_BUFFER_BIT )
	
	if current_mesh:
		current_mesh.update()
		drawGUI( _DR.Button, ("Reset Target: %s" % current_mesh.nmesh.name,10,\
			5, 5, 60, 5 ) )
		
		drawGUI( _DR.Button, ("Update", 12,  70, 5, 20, 5 ))
		
		#selecter
		gui_items[0] = drawGUI( _DR.Menu, ("Choose Selecter %t|Loop %x1000|Normal %x1001",2989,\
			50, 20, 40, 5, gui_items[0].val ) )
		if gui_items[0].val == 1000:
			maxoffset = 3
			fs = current_mesh.getSelectedFaces()
			if fs: maxoffset = len(fs[0].bface.v)-1
			gui_items[1] = drawGUI( _DR.Slider, ("offset ",0,\
				50, 26, 40, 5, gui_items[1].val, 0, maxoffset ) )
		
		elif gui_items[0].val == 1001:
			gui_items[2] = drawGUI( _DR.Slider, ("angle ",0,\
				50, 26, 40, 5, gui_items[2].val, 0., 90. ) )
		drawGUI( _DR.Button, ("select", 300, 5, 20, 40, 11 ) )
		
		#subdivider
		drawGUI( _DR.Button, ("subdivide",200,\
			5, 40, 40, 11 ) )
		gui_items[3] = drawGUI( _DR.Slider, ("level ", 0,\
			50, 40, 40, 5, gui_items[3].val, 1, 10 ) )
		
		#flatter
		drawGUI( _DR.Button, ("flatter",400,\
			5, 60, 40, 11 ))
		gui_items[4] = drawGUI( _DR.Slider, ("factor",0,\
			50,60,40,5, gui_items[4].val, 0.01, 1.0 ))
	else:
		me = getTarget()
		if not me:
			drawText("select something...",5, 5, (1,1,1) )
		elif me.hasFaceUV():
			target_state = 1
			drawGUI( _DR.Button, ("Set Target: %s" % me.name,11,\
				5,5,60,5 ) )
		else:
			target_state = 0
			drawText("must apply TextFace: %s" % me.name, 5,5, (1,1,1))

def event( ev, val ):
	if ( ev == _DR.ESCKEY and not val):
		HogeHoge()

def guievent( ev ):
	global current_mesh, gui_items
	# reset target mesh
	if ev == 10:
		current_mesh = None
		Blender.Redraw()
	
	# set target mesh
	elif ev == 11:
		me = getTarget()
		if me and me.hasFaceUV():
			current_mesh = nmeshx.MeshWrapper(me)
		else:
			print "Error: hasn't FaceUV"
		Blender.Redraw()
	# update target
	elif ev == 12:
		current_mesh.update()
		Blender.Redraw()
	
	# do subdivide
	elif ev == 200:
		if current_mesh:
			current_mesh.update()
			subdivider.doSubdivide( current_mesh, gui_items[3].val )
			Blender.Redraw()
	
	# do select
	elif ev == 300:
		if current_mesh:
			current_mesh.update()
			e = gui_items[0].val
			if e == 1000:
				selecter.LoopSelecter( current_mesh, gui_items[1].val )
			elif e == 1001:
				selecter.NormalSelecter( current_mesh, gui_items[2].val )
			Blender.Redraw()
	
	# do flat
	elif ev == 400:
		if current_mesh:
			current_mesh.update()
			flatter.Flatter( current_mesh, gui_items[4].val )
	
	elif ev == 2989:
		Blender.Redraw()
	
_DR.Register(draw, event, guievent)