"""
	Selecter Module
"""
import math
import math3d
import Blender
import nmeshx


def LoopSelecter( mesh, offset = 0 ):
	global MAX_SELECT
	fs = mesh.getSelectedFaces()
	if len(fs) != 1:
		print "select error"
		return None
	target = fs[0]
	never = 1
	current = target
	cid = offset
	
	while never:
		cedge = current.edges[ (cid+2) % len(current.edges) ]
		if len(cedge.faces) < 2:	break
		next = cedge.faces[ (cedge.faces[0] == current) ]
		if target == next:			break
		mesh.setFaceFlag( next, 1 )
		cid = next.edges.index( cedge )
		current = next
		never += 1
	mesh.toBlender()

def NormalSelecter( mesh, angle ):
	fs = mesh.getSelectedFaces()
	if len(fs) != 1:
		print "select error"
		return None
	stack = [ [fs[0], None ] ]
	normal = fs[0].getNormal()
	radian = math.pi / 180 * angle
	ended = []
	
	fsel = Blender.NMesh.FaceFlags['SELECT']
	fhid = Blender.NMesh.FaceFlags['HIDE']
	
	while stack:
		cu = stack[ len(stack)-1 ]
		comp = 1
		for i in range(len(cu[0].edges)):
			of = cu[0].getAdjacentFace(i)
			if not of:continue
			if of.bface.flag & fhid:continue
			if cu[0].getSharedEdgeID( of ) == cu[1]:continue
			if ended.count( of.id ):continue
			
			cn = of.getNormal()
			dot = normal.Dot( cn )
			if dot > 1:continue
			fr = math.acos( normal.Dot( cn ) )
			if fr > radian:continue
			ended.append( of.id )
			mesh.setFaceFlag( of, fsel )
			stack.append( [of, of.getSharedEdgeID( cu[0] )] )
			comp = 0
			break
		if comp:stack.pop()
	mesh.toBlender()